﻿using Infragistics.Win;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApplication22
{
    public class UltraCheckEditorAsThemedButtonDrawFilter : IUIElementDrawFilter
    {
        bool IUIElementDrawFilter.DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            switch (drawParams.DrawPhase)
            {
                case DrawPhase.BeforeDrawTheme:
                    var checkEditorImageAndTextButtonUIElement = drawParams.Element as CheckEditorImageAndTextButtonUIElement;
                    bool isChecked = checkEditorImageAndTextButtonUIElement.IsChecked;
                    UIElementButtonState state = isChecked ? UIElementButtonState.MouseOver : (UIElementButtonState)0;
                    UltraCheckEditor checkEditor = checkEditorImageAndTextButtonUIElement.Control as UltraCheckEditor;
                    
                    return XPThemes.Button.DrawPushButton(
                        ref drawParams,
                        checkEditorImageAndTextButtonUIElement.Rect,
                        drawParams.InvalidRect,
                        state,
                        false);

                case DrawPhase.BeforeDrawBackColor:
                case DrawPhase.BeforeDrawBorders:
                case DrawPhase.BeforeDrawImageBackground:
                    return true;
                    
            }

            return false;
        }

        DrawPhase IUIElementDrawFilter.GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            var element = drawParams.Element;
            if (element is CheckEditorImageAndTextButtonUIElement)
            {
                return DrawPhase.BeforeDrawTheme |
                    DrawPhase.BeforeDrawBackColor |
                    DrawPhase.BeforeDrawBorders |
                    DrawPhase.BeforeDrawImageBackground
                    ;                
            }

            return DrawPhase.None;
        }
    }
}
